
/*************************************
**									**
**			Laserblast				**
**									**
**		  Version 1.0.1				**
**	   Created on 4.5.2014			**
**		 Richard Beckmann			**
**									**
*************************************/

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <stdarg.h>
#include <math.h>
#include <time.h>
#include <conio.h>
#include <windows.h>
#include <string.h>

#define left 1
#define right 2
#define down 3
#define up 4

#define wTerm 80
#define hTerm 25

//1000 - 1999 = Figuren wie Spieler, Gegner, etc.
#define playerType 1000
#define enemyType 1001
#define enemyBigType 1002

//2000 - 2999 = Schuesse
#define playerShotType 2000
#define enemyShotType 2001
#define enemyShotHardType 2002

#define playerMax 1
#define enemyMax 12
#define enemyBigMax 8
#define playerShotMax 16
#define enemyShotMax 48
#define enemyShotHardMax 24


int timeval;
//int timevalProMille;
int world[hTerm][wTerm];
int amountEnemyShoot;
int amountEnemyShootHard;
int enemyspawnTime;
int enemyBigspawnTime;
int level;
int hits;
bool gameover;


typedef struct ObjectLocation
{
	int type;
	int typeOld;
	int cloneNumber;
} location;

location objectLocation[hTerm][wTerm];


struct Object
{
	int x;
	int y;
	int health;
	int healthAtStart;
	int damage;
	int velocity;
	bool exists;
	int timeDeleted;
	int timeHit;
	int timeMoved;
	int timeSpawned;
	int type;
	int cloneNumber;
	char picture[5];
};

struct Player
{
	struct Object o;
	int timeShot;
	int score;
};

struct Enemy
{
	struct Object o;
	int timeShot;
	bool shoot;
	bool shootHard;
};

struct EnemyBig
{
	struct Object o;
	int timeShot;
	int shots;
};

struct PlayerShot
{
	struct Object o;
};

struct EnemyShot
{
	struct Object o;
};

struct EnemyShotHard
{
	struct Object o;
};

struct Player player[playerMax];
struct Enemy enemy[enemyMax];
struct EnemyBig enemyBig[enemyBigMax];
struct PlayerShot playerShot[playerShotMax];
struct EnemyShot enemyShot[enemyShotMax];
struct EnemyShotHard enemyShotHard[enemyShotHardMax];


//Function Prototype


void destroy(struct Object *o,int direction);
void objectDelete(struct Object *o);


//Windows Cursor Funktionen


void setCursor(bool visible)
{
	HANDLE hout = GetStdHandle(STD_OUTPUT_HANDLE);
	CONSOLE_CURSOR_INFO cci;

	GetConsoleCursorInfo(hout,&cci);
	cci.bVisible = !!visible;
	SetConsoleCursorInfo(hout,&cci);
}

void setCursorPos(int x,int y)
{
	COORD c = {x,y};
	SetConsoleCursorPosition(GetStdHandle(STD_OUTPUT_HANDLE),c);
}

void getCursorPos(int *x,int *y)
{
	CONSOLE_SCREEN_BUFFER_INFO Coords;
	HANDLE hStd = GetStdHandle(STD_OUTPUT_HANDLE);
	GetConsoleScreenBufferInfo(hStd, &Coords);
	*x = Coords.dwCursorPosition.X;
	*y = Coords.dwCursorPosition.Y;
}


//Funktionen


void createWorld()
{
	int n;
	int m;
	setCursorPos(0,0);
	for(n = 0; n < hTerm; n++){
		for(m = 0; m < wTerm; m++){
			world[n][m] = ' ';
			objectLocation[n][m].type = world[n][m];
			objectLocation[n][m].typeOld = world[n][m];
			objectLocation[n][m].cloneNumber = -1;
			printf("%c",world[n][m]);
		}
	}
	setCursorPos(0,0);
}

/*int updateWorld()
{
	int n;
	int m;
	setCursorPos(0,0);
	for(n = 0; n < hTerm; n++){
		for(m = 0; m < wTerm; m++){
			printf("%c",world[n][m]);
		}
		if (n < hTerm - 1){
			setCursorPos(0,n + 1);
		}
	}
	setCursorPos(0,0);
	return 0;
}*/


bool printfWorld(int x,int y,const char *format,...)
{
	int i;
	char str[wTerm];
	va_list list;
	va_start(list,format);
	vsprintf(str,format,list);
	va_end(list);
	if (y < hTerm && x + strlen(str) < wTerm){
		for(i = 0;str[i] != '\0' && x + i < wTerm;i++){
			world[y][x + i] = str[i];
			objectLocation[y][x + i].type = str[i];
			objectLocation[y][x + i].typeOld = str[i];
		}
		setCursorPos(x,y);
		printf(str);
		return true;
	}
	return false;
}


void printHealth(struct Object *o)
{
	int i;
	int x = 18;
	int y = 0;
	setCursorPos(x,y);
	for(i = 0;i < o->health;i++){
		printf("%c",3);
		objectLocation[y][x + i].type = 3;
		objectLocation[y][x + i].typeOld = 3;
	}
	while (objectLocation[y][x + i].typeOld == 3){
		objectLocation[y][x + i].typeOld = world[y][x + i];
		if (objectLocation[y][x + i].type == 3){
			printf("%c",world[y][x + i]);
			objectLocation[y][x + i].type = world[y][x + i];
		}
		i++;
	}
}


void hitsup()
{
	hits += !gameover;
	printfWorld(41,0,"%d",hits);
}


void GameOver()
{
	int z = 0;
	gameover = true;
	printfWorld((wTerm - 9) / 2,(hTerm - 2) / 2,"GAME OVER");
	if (level == 1){
		printfWorld((wTerm - 28) / 2,(hTerm - 2) / 2 + 2,"Learn How To Play. You Noob!");
		z = 2;
	}
	printfWorld((wTerm - 22) / 2,(hTerm - 2) / 2 + 2 + z,"Press 'r' To Try Again");
}


//Function with Object


bool spawn(struct Object *o,int x,int y)
{
	int i,type;
	int length = strlen(o->picture);
	o->x = x;
	o->y = y;
	o->exists = true;
	o->timeSpawned = timeval;
	o->timeMoved = o->timeSpawned;
	o->health = o->healthAtStart;
	for(i = 0; i < length; i++){
		type = objectLocation[y][x - length / 2 + i].type;
		if (type < 1000){
			objectLocation[y][x - length / 2 + i].type = o->type;
			objectLocation[y][x - length / 2 + i].cloneNumber = o->cloneNumber;
		}
		else{
			destroy(o,0);
			if (o->health <= 0){
				return false;
			}
		}


	}
	setCursorPos(o->x - length / 2,o->y);
	printf("%s",o->picture);
	return true;
}


bool moveUpdate(struct Object *o,int direction)
{
	int i,typeOld,cloneNumber;
	int length = strlen(o->picture);
	int type = 0;
	setCursorPos(o->x - length / 2,o->y);
	for(i = 0; i < length; i++){
		type = objectLocation[o->y - (direction >= 3) * ((direction - 2) * 2 - 3)][o->x + (direction <= 2) * (direction * 2 - 3) - (length / 2) + i].type;
		cloneNumber = objectLocation[o->y - (direction >= 3) * ((direction - 2) * 2 - 3)][o->x + (direction <= 2) * (direction * 2 - 3) - (length / 2) + i].cloneNumber;
		if (type >= 1000 && (type != o->type || cloneNumber != o->cloneNumber)){
			destroy(o,direction);
			if (o->health <= 0){
				return false;
			}
		}
		typeOld = objectLocation[o->y][o->x - length / 2 + i].typeOld;
		printf("%c",typeOld);
		objectLocation[o->y][o->x - length / 2 + i].type = typeOld;
		objectLocation[o->y][o->x - length / 2 + i].cloneNumber = -1;
	}
	if (o->timeHit != -1){
		return false;
	}
	o->x += (direction <= 2) * (direction * 2 - 3);
	o->y -= (direction >= 3) * ((direction - 2) * 2 - 3);
	for(i = 0; i < length; i++){
		if (type < 1000){
			typeOld = objectLocation[o->y][o->x - length / 2 + i].type;
		}
		else{
			typeOld = world[o->y][o->x - length / 2 + i];
		}
		objectLocation[o->y][o->x - length / 2 + i].typeOld = typeOld;
		objectLocation[o->y][o->x - length / 2 + i].type = o->type;
		objectLocation[o->y][o->x - length / 2 + i].cloneNumber = o->cloneNumber;
	}
	setCursorPos(o->x - length / 2,o->y);
	printf("%s",o->picture);
	o->timeMoved = timeval;
	return true;
}


void disappear(struct Object *o)
{
	int i;
	int length = strlen(o->picture);
	for(i = 0; i < length; i++){
		objectLocation[o->y][o->x - length / 2 + i].cloneNumber = -1;
		objectLocation[o->y][o->x - length / 2 + i].type = world[o->y][o->x - length / 2 + i];
		setCursorPos(o->x - length / 2 + i,o->y);
		printf("%c",world[o->y][o->x - length / 2 + i]);
	}
	o->timeHit = timeval;
}


bool appear(struct Object *o)
{
	int i,type;
	int length = strlen(o->picture);
	for(i = 0; i < length; i++){
		type = objectLocation[o->y][o->x - length / 2 + i].type;
		if (type < 1000){
			objectLocation[o->y][o->x - length / 2 + i].type = o->type;
			objectLocation[o->y][o->x - length / 2 + i].cloneNumber = o->cloneNumber;
		}
		else{
			destroy(o,0);
			if (o->health <= 0){
				return false;
			}
		}
	}
	setCursorPos(o->x - length / 2,o->y);
	printf("%s",o->picture);
	o->timeHit = -1;
	return true;
}


void clear(struct Object *o,bool printHashtag)
{
	int i;
	int length = strlen(o->picture);
	if (printHashtag == false){
		objectDelete(o);
		return;
	}
	if (objectLocation[o->y][o->x].typeOld == '#'){
		objectDelete(o);
	}
	setCursorPos(o->x - length / 2,o->y);
	for(i = 0; i < length; i++){
		o->timeDeleted = timeval;
		printf("%c",'#');
		objectLocation[o->y][o->x - length / 2 + i].type = '#';
		objectLocation[o->y][o->x - length / 2 + i].typeOld = '#';
		objectLocation[o->y][o->x - length / 2 + i].cloneNumber = -1;
	}
}


void destroy(struct Object *o,int direction)
{
	int length = strlen(o->picture);
	int i, type, cloneNumber, typePre, cloneNumberPre;
	bool deleted = false;

	//Wenn direction 0 ist, dann ist die Position des Types gleich wie die von Objekten selbst.


	void dealDamage(struct Object *_o)
	{
		_o->health -= o->damage;
		o->health -= _o->damage;
		if (_o->health <= 0){
			clear(_o,type >= 1000 && type < 2000);
			deleted = true;
		}
		else if (_o->type >= 1000 && _o->type < 2000){
			typePre = o->type;
			cloneNumberPre = o->cloneNumber;
			disappear(_o);
		}
	}


	for(i = 0;i < length;i++){
		type = objectLocation[o->y - (direction >= 3) * ((direction - 2) * 2 - 3) * (direction > 0)][o->x + (direction <= 2) * (direction * 2 - 3) * (direction > 0) - (length / 2) + i].type;
		cloneNumber = objectLocation[o->y - (direction >= 3) * ((direction - 2) * 2 - 3) * (direction > 0)][o->x + (direction <= 2) * (direction * 2 - 3) * (direction > 0) - (length / 2) + i].cloneNumber;
		if ((i != 0 && type == typePre && cloneNumber == cloneNumberPre) || (cloneNumber == o->cloneNumber && type == o->type)){

		}
		else if (type == playerType){
			dealDamage(&player[cloneNumber].o);
			printHealth(&player[cloneNumber].o);
			if (player[cloneNumber].o.health <= 0){
				GameOver();
			}
		}
		else if (type == enemyType){
			dealDamage(&enemy[cloneNumber].o);
			if (enemy[cloneNumber].o.health <= 0){
				hitsup();
			}
		}
		else if (type == enemyBigType){
			dealDamage(&enemyBig[cloneNumber].o);
			if (enemyBig[cloneNumber].o.health <= 0){
				hitsup();
			}
		}
		else if (type == playerShotType && !(o->type >= 2000)){
			dealDamage(&playerShot[cloneNumber].o);
		}
		else if (type == enemyShotType && !(o->type >= 2000)){
			dealDamage(&enemyShot[cloneNumber].o);
		}
		else if (type == enemyShotHardType && !(o->type >= 2000)){
			dealDamage(&enemyShotHard[cloneNumber].o);
		}
	}
	if (o->health > 0 && o->type >= 1000 && o->type < 2000){
		disappear(o);
	}
	if (((o->type >= 1000 && o->type < 2000) || (direction == 0 && (type >= 1000 && type < 2000) && deleted)) && o->health <= 0){
		clear(o,true);
	}
	else if ((o->type >= 2000) && !(type >= 2000) && o->health <= 0){
		clear(o,false);
	}
	if ((o->type == enemyType || o->type == enemyBigType) && o->health <= 0){
		hitsup();
	}
	else if (o->type == playerType){
		printHealth(&player[0].o);
		if (player[0].o.health <= 0){
			GameOver();
		}

	}

	/*for(i = 0;i < enemyMax;i++){
		if (e[i].o.exists == true){
			for(j = 0;j < playerShotMax;j++){
				if (ps[j].o.exists == true && e[i].o.x==ps[j].o.x && e[i].o.y==ps[j].o.y){
					objectDelete(&ps[j]);
					objectDelete(&e[i]);
				}
			}
		}
	}*/
}


bool isObject(struct Object *would_check,struct Object *would_spawn,int x) //x = Welche Spalte
{
	int i,j;
	int length = strlen(would_spawn->picture);
	for(i = 0;i < length;i++){
		for(j = 0;j < hTerm;j++){
			if (objectLocation[j][x - length / 2 + i].type == would_check->type){
				return true;
			}
		}
	}
	return false;
}


void objectDelete(struct Object *o)
{
	int i,typeOld;
	int length = strlen(o->picture);
	for(i = 0; i < length; i++){
		typeOld = objectLocation[o->y][o->x - length / 2 + i].typeOld;
		setCursorPos(o->x - length / 2 + i,o->y);
		if ((o->type >= 1000 && o->type < 2000 && typeOld == '#') || typeOld != '#'){
			if (typeOld != world[o->y][o->x - length / 2 + i] && typeOld != '#'){
				printf("%c",typeOld);
				objectLocation[o->y][o->x - length / 2 + i].type = typeOld;
			}
			else{
				if (objectLocation[o->y][o->x - length / 2 + i].cloneNumber == -1 || typeOld != '#'){
					printf("%c",world[o->y][o->x - length / 2 + i]);
				}
				objectLocation[o->y][o->x - length / 2 + i].typeOld = world[o->y][o->x - length / 2 + i];
				objectLocation[o->y][o->x - length / 2 + i].type = world[o->y][o->x - length / 2 + i];
			}
		}
		else{
			printf("%c",'#');
			objectLocation[o->y][o->x - length / 2 + i].type = '#';
		}
		objectLocation[o->y][o->x - length / 2 + i].cloneNumber = -1;
	}
	o->exists = false;
	o->timeHit = -1;
	o->timeDeleted = -1;
}


//Object Function


void playerFunction(struct Player *p)
{
	void move()
	{
		int length = strlen(p->o.picture);
		if (GetAsyncKeyState( VK_LEFT ) & 0x8000 && GetAsyncKeyState( VK_RIGHT ) & 0x8000){

		}
		else if (GetAsyncKeyState( VK_LEFT ) & 0x8000 && p->o.x > length / 2){
			moveUpdate(&p->o,left);
		}
		else if (GetAsyncKeyState( VK_RIGHT ) & 0x8000 && p->o.x < wTerm - length / 2 - length % 2){
			moveUpdate(&p->o,right);
		}
	}

	bool shoot()
	{
		int i;
		if (p->o.y != 0){
			for(i = 0; i < playerShotMax; i++){
				if (playerShot[i].o.exists == false){
					spawn(&playerShot[i].o,p->o.x,p->o.y - 1);
					p->timeShot = timeval;
					return true;
				}
			}
		}
		return false;
	}


	if (p->o.timeDeleted == -1 && p->o.timeHit == -1){
		if (timeval >= p->o.timeMoved + p->o.velocity){
			move();
		}
		if ((GetAsyncKeyState( ' ' ) & 0x8000 || GetAsyncKeyState( SHIFT_PRESSED ) & 0x8000) && p->timeShot <= timeval - p->o.velocity * 2){
			shoot();
		}
	}
	else if(p->o.timeHit != -1 && p->o.timeHit < timeval - 40){
		appear(&p->o);
	}
	else if(p->o.timeDeleted != -1 && p->o.timeDeleted <= timeval - 1000){
		objectDelete(&p->o);
	}
}

void enemyFunction(struct Enemy *e)
{
	void move()
	{
		moveUpdate(&e->o,down);
	}

	bool shoot()
	{
		int i;
		if (e->o.y != hTerm - 1){
			if (e->shoot){
				for(i = 0; i < enemyShotMax; i++){
					if (enemyShot[i].o.exists == false){
						spawn(&enemyShot[i].o,e->o.x,e->o.y + 1);
						e->timeShot = timeval;
						return true;
					}
				}
			}
			else if (e->shootHard){
				for(i = 0; i < enemyShotHardMax; i++){
					if (enemyShotHard[i].o.exists == false){
						spawn(&enemyShotHard[i].o,e->o.x,e->o.y + 1);
						e->timeShot = timeval;
						return true;
					}
				}
			}
		}
		return false;
	}


	int shotDistancePlayer;
	int type = objectLocation[e->o.y + 1][e->o.x].type;
	if (e->o.timeDeleted == -1 && e->o.timeHit == -1){
		if (timeval >= e->o.timeMoved + e->o.velocity){
			if (e->o.y != hTerm - 1 && type != enemyShotType && type != enemyShotHardType){
				move();
			}
			else if (e->o.y == hTerm - 1){
				objectDelete(&e->o);
			}
		}
		shotDistancePlayer = (player[0].o.y - e->o.y) * (enemyShot[0].o.velocity * e->shoot + enemyShotHard[0].o.velocity * e->shootHard * 1.4) / player[0].o.velocity;
		if ((e->timeShot <= timeval - 725 + 200 * e->shootHard - rand() % 150 || e->timeShot == -1) && (player[0].o.x <= e->o.x + shotDistancePlayer + 1 && player[0].o.x >= e->o.x - shotDistancePlayer) && (player[0].o.exists && player[0].o.timeDeleted == -1)){
			shoot();
		}
	}
	else if(e->o.timeHit != -1 && e->o.timeHit < timeval - 40){
		appear(&e->o);
	}
	else if(e->o.timeDeleted != -1 && e->o.timeDeleted <= timeval - 1000){
		objectDelete(&e->o);
	}
}

void enemyBigFunction(struct EnemyBig *eb)
{
	void move()
	{
		moveUpdate(&eb->o,down);
	}

	bool shoot(int side,int shotType)  //0 = left, 1 = middle, 2 = right
	{
		int i;
		if (eb->o.y != hTerm - 1){
			if (shotType == 0){
				for(i = 0; i < enemyShotMax; i++){
					if (enemyShot[i].o.exists == false){
						spawn(&enemyShot[i].o,eb->o.x - 1 + side,eb->o.y + 1);
						eb->timeShot = timeval;
						eb->shots += 1;
						return true;
					}
				}
			}
			else if (shotType == 1){
				for(i = 0; i < enemyShotHardMax; i++){
					if (enemyShotHard[i].o.exists == false){
						spawn(&enemyShotHard[i].o,eb->o.x - 1 + side,eb->o.y + 1);
						eb->timeShot = timeval;
						eb->shots += 1;
						return true;
					}
				}
			}
		}
		return false;
	}


	int shotDistancePlayer,type,i;
	int length = strlen(eb->o.picture);
	bool go = true;
	for(i = 0;i < length && go;i++){
		type = objectLocation[eb->o.y + 1][eb->o.x - 1 + i].type;
		go = type != enemyShotType && type != enemyShotHardType;
	}
	if (eb->o.timeDeleted == -1 && eb->o.timeHit == -1){
		if (timeval >= eb->o.timeMoved + eb->o.velocity){
			if (eb->o.y != hTerm - 1 && go){
				move();
			}
			else if (eb->o.y == hTerm - 1){
				objectDelete(&eb->o);
			}
		}
		shotDistancePlayer = (player[0].o.y - eb->o.y) * (/*enemyShot[0].o.velocity * eb->shoot + */enemyShotHard[0].o.velocity * 1.15) / player[0].o.velocity;
		if ((eb->timeShot <= timeval - 550 - rand() % 100 || eb->timeShot == -1) && (player[0].o.x <= eb->o.x + shotDistancePlayer + 1 && player[0].o.x >= eb->o.x - shotDistancePlayer) && (player[0].o.exists && player[0].o.timeDeleted == -1)){
			shoot((!(eb->shots % 5) && level >= 4) + eb->shots % 2 * 2 * (!!(eb->shots % 5) || (level < 4)),!(!(eb->shots % 5) && (level >= 4)));
		}
	}
	else if(eb->o.timeHit != -1 && eb->o.timeHit < timeval - 40){
		appear(&eb->o);
	}
	else if(eb->o.timeDeleted != -1 && eb->o.timeDeleted <= timeval - 1000){
		objectDelete(&eb->o);
	}
}

void playerShotFunction(struct PlayerShot *ps)
{
	void move()
	{
		moveUpdate(&ps->o,up);
	}


	if (timeval >= ps->o.timeMoved + ps->o.velocity){
		if (ps->o.y != 0){
			move();
		}
		else{
			objectDelete(&ps->o);
		}
	}
}

void enemyShotFunction(struct EnemyShot *es)
{
	void move()
	{
		moveUpdate(&es->o,down);
	}

	if (timeval >= es->o.timeMoved + es->o.velocity){
		if (es->o.y != hTerm - 1){
			move();
		}
		else{
			objectDelete(&es->o);
		}
	}
}

void enemyShotHardFunction(struct EnemyShotHard *esh)
{
	void move()
	{
		moveUpdate(&esh->o,down);
	}

	if (timeval >= esh->o.timeMoved + esh->o.velocity){
		if (esh->o.y != hTerm - 1){
			move();
		}
		else{
			objectDelete(&esh->o);
		}
	}
}


void render()
{
	int i;

	Sleep(4);
	timeval = clock();

	for(i = 0; i < playerMax; i++){
		if (player[i].o.exists == true){
			playerFunction(&player[i]);
		}
	}
	for(i = 0; i < enemyMax; i++){
		if (enemy[i].o.exists == true){
			enemyFunction(&enemy[i]);
		}
	}
	for(i = 0; i < enemyBigMax; i++){
		if (enemyBig[i].o.exists == true){
			enemyBigFunction(&enemyBig[i]);
		}
	}
	for(i = 0; i < playerShotMax; i++){
		if (playerShot[i].o.exists == true){
			playerShotFunction(&playerShot[i]);
		}
	}
	for(i = 0; i < enemyShotMax; i++){
		if (enemyShot[i].o.exists == true){
			enemyShotFunction(&enemyShot[i]);
		}
	}
	for(i = 0; i < enemyShotHardMax; i++){
		if (enemyShotHard[i].o.exists == true){
			enemyShotHardFunction(&enemyShotHard[i]);
		}
	}
}


void initialize_o(struct Object *o,const char *picture,int health,int damage,int velocity,int type,int cloneNumber)
{
	strcpy(o->picture,picture);
	o->exists = false;
	o->health = health;
	o->healthAtStart = health;
	o->damage = damage;
	o->velocity = velocity;
	o->timeDeleted = -1;
	o->timeHit = -1;
	o->timeMoved = -1;
	o->timeSpawned = -1;
	o->type = type;
	o->cloneNumber = cloneNumber;
}


//Restart


void start()
{
	int i;

	timeval = 0;
	//timevalProMille = 0;
	amountEnemyShoot = 20;
	amountEnemyShootHard = 0;
	enemyspawnTime = 2000;
	enemyBigspawnTime = -1;
	level = 1;
	hits = 0;
	gameover = false;

	srand(time(NULL));

	//Object define and initialize

	for(i = 0; i < playerMax; i++){
		initialize_o(&player[i].o,"[@]",4,4,70,playerType,i);
		player[i].timeShot = -1;
	}
	for(i = 0; i < enemyMax; i++){
		initialize_o(&enemy[i].o,"O",2,3,300,enemyType,i);
		enemy[i].timeShot = -1;
	}
	for(i = 0; i < enemyBigMax; i++){
		initialize_o(&enemyBig[i].o,"|O|",4,4,400,enemyBigType,i);
		enemyBig[i].timeShot = -1;
		enemyBig[i].shots = 0;
	}
	for(i = 0; i < playerShotMax; i++){
		initialize_o(&playerShot[i].o,"|",1,2,23,playerShotType,i);
	}
	for(i = 0; i < enemyShotMax; i++){
		initialize_o(&enemyShot[i].o,"*",1,1,50,enemyShotType,i);
	}
	for(i = 0; i < enemyShotHardMax; i++){
		initialize_o(&enemyShotHard[i].o,"|",1,2,23,enemyShotHardType,i);
	}

	createWorld();

	spawn(&player[0].o,wTerm / 2 - 1,hTerm - 2);

	printfWorld(11,0,"Health");
	printHealth(&player[0].o);

	printfWorld(wTerm / 2 - 4,0,"Hits");
	printfWorld(wTerm / 2 + 1,0,"%d",hits);

	printfWorld(59,0,"Level");
	printfWorld(65,0,"%d",level);
}


//Main Function


int main()
{

	int i,spawnX; //cl = cloneNumber
	int cle_old = 0;
	int cleb_old = 0;

	SetConsoleTitle("Laserblast");

	setCursor(false);

	start();

	//Object Render

	while (true){
		render();

		//spawn enemy

		if (enemy[cle_old].o.timeSpawned <= timeval - enemyspawnTime){
			for(i = 0; i < enemyMax; i++){
				if (enemy[i].o.exists == false){
					do{
						spawnX = rand() % (wTerm - 2 * 4) + 4;
					}while(isObject(&enemyBig[0].o,&enemy[0].o,spawnX));
					spawn(&enemy[i].o,spawnX,0);
					enemy[i].shootHard = rand() % 100 < amountEnemyShootHard;
					if (!enemy[i].shootHard){
						enemy[i].shoot = rand() % 100 < amountEnemyShoot;
					}
					enemyspawnTime = 2000 / pow(1.2,level - 1) + 200 - rand() % 400;
					cle_old = i;
					break;
				}
			}
		}
		if (level >= 3 && enemyBigspawnTime == -1){
			enemyBigspawnTime = 8000;
		}
		if (enemyBig[cleb_old].o.timeSpawned <= timeval - enemyBigspawnTime && enemyBigspawnTime != -1){
			for(i = 0; i < enemyBigMax; i++){
				if (enemyBig[i].o.exists == false){
					do{
						spawnX = rand() % (wTerm - 2 * 5) + 5;
					}while(isObject(&enemyBig[0].o,&enemyBig[0].o,spawnX));
					spawn(&enemyBig[i].o,spawnX,0);
					enemyBigspawnTime = 8000 / pow(1.4,level - 3) + 1000 - rand() % 2000;
					cleb_old = i;
					break;
				}
			}
		}

		//level up

		if (4 * (((level + 1) * (level + 2) / 2) - 1) == hits){
			level += 1;
			printfWorld(65,0,"%d",level);

			amountEnemyShoot += 8;
			amountEnemyShootHard += 5;

			for(i = 0; i < enemyMax; i++){
				enemy[i].o.velocity /= 1.13;
			}
			for(i = 0; i < enemyBigMax; i++){
				enemyBig[i].o.velocity /= 1.05;
			}
		}
		//if (gameover){
			if (GetAsyncKeyState( 'R' ) & 0x8000){
				start();
			}
		//}
	}

	setCursor(true);

	return 0;
}
